#!/bin/sh
#
#     This library is free software; you can redistribute it and/or modify it
#     under the terms of the GNU Lesser General Public License as published by
#     the Free Software Foundation; either version 2.1 of the License, or (at
#     your option) any later version.
#			      
#     This library is distributed in the hope that it will be useful, but
#     WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#     Lesser General Public License for more details.
#      
#     You should have received a copy of the GNU Lesser General Public
#     License along with this library; if not, write to the Free Software
#     Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1335
#     USA.
#
# /etc/init.d/bandwith
#   and its symbolic link
# /usr/sbin/rcbandwith
#
# LSB compatible service control script; see http://www.linuxbase.org/spec/
# 
### BEGIN INIT INFO
# Provides:          bandwidth
# Required-Start:    $syslog $remote_fs $network
# Should-Start:      $time smtp
# Required-Stop:     $syslog $remote_fs $network
# Should-Stop:       smtp
# Default-Start:     3 5
# Default-Stop:      0 1 2 6
# Short-Description: Bandwith limiting
# Description:       Start bandwidth to limit your upload/download 
#	speed. The script uses the 'tc' command to manipulate the traffic
#	control settings of the running kernel.
### END INIT INFO
#

# Check for missing binaries (stale symlinks should not happen)
# Note: Special treatment of stop for LSB conformance
TC_BIN="/usr/sbin/tc"
test -x $TC_BIN || { echo "$TC_BIN not installed"; 
	if [ "$1" = "stop" ]; then exit 0;
	else exit 5; fi; }

ETHTOOL_BIN="/sbin/ethtool"
test -x $ETHTOOL_BIN || { echo "$ETHTOOL_BIN not installed";
    if [ "$1" = "stop" ]; then exit 0;
    else exit 5; fi; }

# Check for existence of needed config file and read it
BANDWIDTH_CONFIG="/etc/sysconfig/bandwidth"
test -r $BANDWIDTH_CONFIG || { echo "$BANDWIDTH_CONFIG not existing";
	if [ "$1" = "stop" ]; then exit 0;
	else exit 6; fi; }

# Read config	
. $BANDWIDTH_CONFIG

# Source LSB init functions
. /etc/rc.status

# Reset status of this service
rc_reset

# Return values acc. to LSB for all commands but status:
# 0	  - success
# 1       - generic or unspecified error
# 2       - invalid or excess argument(s)
# 3       - unimplemented feature (e.g. "reload")
# 4       - user had insufficient privileges
# 5       - program is not installed
# 6       - program is not configured
# 7       - program is not running
# 8--199  - reserved (8--99 LSB, 100--149 distrib, 150--199 appl)
# 
# Note that starting an already running service, stopping
# or restarting a not-running service as well as the restart
# with force-reload (in case signaling is not supported) are
# considered a success.

if [ -z "$BANDWIDTH_IF" ]; then
	echo "Variable BANDWIDTH_IF not set in $BANDWIDTH_CONFIG";
    if [ "$1" = "stop" ]; then 
		exit 0;
    else 
		exit 6; 
	fi;
fi

if [ -z "$BANDWIDTH_SPEED" ]; then
	echo "Variable BANDWIDTH_SPEED not set in $BANDWIDTH_CONFIG";
    if [ "$1" = "stop" ]; then
        exit 0;
    else
        exit 6;
    fi;
fi

case "$1" in
    start)
	echo -n "Configuring bandwith limit "

	for IF in $BANDWIDTH_IF; do
        $ETHTOOL_BIN -K $IF tso off
	    $TC_BIN qdisc add dev $IF root handle 1: htb default 11 r2q 200
	    $TC_BIN class add dev $IF parent 1: classid 1:11 htb rate ${BANDWIDTH_SPEED}mbit
	    $TC_BIN qdisc add dev $IF parent 1:11 handle 11: sfq
	done

	echo "${SPEED}" > /var/run/bandwith

	# Remember status and be verbose
	rc_status -v
	;;
    stop)
	echo -n "Deleting bandwidth shaping "
    for IF in $BANDWIDTH_IF; do
		$TC_BIN qdisc del dev $IF root
        $ETHTOOL_BIN -K $IF tso on
	done
	test -f /var/run/bandwith && rm /var/run/bandwith

	# Remember status and be verbose
	rc_status -v
	;;
    try-restart|condrestart)
	## Do a restart only if the service was active before.
	## Note: try-restart is now part of LSB (as of 1.9).
	## RH has a similar command named condrestart.
	if test "$1" = "condrestart"; then
		echo "${attn} Use try-restart ${done}(LSB)${attn} rather than condrestart ${warn}(RH)${norm}"
	fi
	$0 status
	if test $? = 0; then
		$0 restart
	else
		rc_reset	# Not running is not a failure.
	fi
	# Remember status and be quiet
	rc_status
	;;
    restart)
	## Stop the service and regardless of whether it was
	## running or not, start it again.
	$0 stop
	$0 start

	# Remember status and be quiet
	rc_status
	;;
    force-reload)
	## Signal the daemon to reload its config. Most daemons
	## do this on signal 1 (SIGHUP).
	## If it does not support it, restart the service if it
	## is running.

	echo -n "Reload service bandwidth "
	$0 try-restart
	rc_status
	;;
    reload)
	rc_failed 3
	rc_status -v
	;;
    status)
	echo -n "Checking bandwidth limit setup "
	# Return value is slightly different for the status command:
	# 0 - service up and running
	# 1 - service dead, but /var/run/  pid  file exists
	# 2 - service dead, but /var/lock/ lock file exists
	# 3 - service not running (unused)
	# 4 - service status unknown :-(
	# 5--199 reserved (5--99 LSB, 100--149 distro, 150--199 appl.)
	if [ -f /var/run/bandwith ]; then
		rc_failed 0
	else
		rc_failed 3
	fi	

	# NOTE: rc_status knows that we called this init script with
	# "status" option and adapts its messages accordingly.
	rc_status -v
	;;
    *)
	echo "Usage: $0 {start|stop|status|try-restart|restart|force-reload|reload}"
	exit 1
	;;
esac
rc_exit
